unit Main;

interface

uses
  Windows, Messages, SysUtils, Graphics, Classes, Forms, Clipbrd, Dialogs,
  Base, ComCtrls, ExtCtrls, Grids, Controls, StdCtrls;

const
    WM_POSTRENDER = WM_USER + 100;

type
    TMainForm = class(TBaseForm)
        Grid: TDrawGrid;
    ImgTitle: TImage;
        procedure	FormActivate(Sender: TObject);
        procedure	FormCreate(Sender: TObject);
        procedure	FormDestroy(Sender: TObject);
        procedure	GridDrawCell(Sender: TObject; ACol, ARow: Integer;
							        Rect: TRect; State: TGridDrawState);
        procedure FormShow(Sender: TObject);
    procedure ImgTitleClick(Sender: TObject);
    private
        { Private 錾 }
        fGridBitmap	: TBitmap;
        FGridPreProc: TWndMethod;
        fGridMarginX: integer;
        fGridMarginY: integer;
        fStringList	: TStringList;
        procedure	SetDrawCondition();
        procedure	GridWndProc(var Msg: TMessage);
        function	GetPasteData: string;
        procedure	WMRender(var Msg: TWMRenderFormat); message WM_RENDERFORMAT;
        procedure	WMPostRender(var Msg: TMessage); message WM_POSTRENDER;
        procedure	SetRender;
		function	GetString(AIndex: integer): string;
        procedure	ModifySysMenu();
        procedure	WMSysCommand(var Msg: TWMSysCommand); message WM_SYSCOMMAND;
    public
        { Public 錾 }
    protected
        procedure	DroppedAction(); override;
    end;

var
  MainForm: TMainForm;

implementation

uses
	About;

{$R *.DFM}

(*
	=====================================================================
	Nbv{[h
	=====================================================================
*)
(* x_Os߂ɁANbv{[h̃f[^nhNULLɃZbg *)
procedure TMainForm.SetRender();
begin
    OpenClipboard(Handle);
    EmptyClipboard;
    SetClipboardData(CF_TEXT, 0);
    CloseClipboard;
end;
//-----------------------------------------------
procedure TMainForm.FormActivate(Sender: TObject);
begin
    SetRender;
end;

(* AvP[Vł̓\to *)
procedure TMainForm.WMRender(var Msg: TWMRenderFormat);
var
	Txt: String;
    Data: THandle;
    Buff: Pointer;
begin
    // ۂ̃f[^_O
    OpenClipboard(Handle);
    EmptyClipboard;
    Txt := GetPasteData;
    Data := GlobalAlloc(GMEM_MOVEABLE, Length(Txt) + 1);
    Buff := GlobalLock(Data);
    StrCopy(Buff, PChar(Txt));
    SetClipboardData(CF_TEXT, Data);
    GlobalUnlock(Data);
    PostMessage(Handle, WM_POSTRENDER, 0, 0);
end;

(* ̓\tɔ *)
procedure TMainForm.WMPostRender(var Msg: TMessage);
begin
    Sleep(100);
    SetRender;
end;

(* f[^o *)
function TMainForm.GetPasteData: string;
begin
    Result := GetString(Grid.Row);
	if Grid.Row < Grid.RowCount - 1 then
    begin
	    Grid.Row := Grid.Row + 1;
    end else
    begin
	    Grid.Row := 0;
    end;
end;

(*
	=====================================================================
	p\bhI[o[[h
	=====================================================================
*)
(* DroppedAction *)
procedure	TMainForm.DroppedAction();
begin
    if DropFileList.Count > 0 then
    begin
    	LoadFromFile(DropFileList[0], fStringList, True);
		Self.Caption := DropFileList[0];
        Grid.RowCount := fStringList.Count;
        Grid.Row := 0;
        Grid.Repaint;
    end;
end;

(*
	=====================================================================
	RXgN^EfXgN^
	=====================================================================
*)
(* RXgN^ *)
procedure TMainForm.FormCreate(Sender: TObject);
begin
    inherited;
    ModifySysMenu();
    fStringList		:= nil;
    fStringList		:= TStringList.Create;
    fGridBitmap     := nil;
    fGridBitmap     := TBitmap.Create;
    SetDrawCondition();
end;

(* fXgN^ *)
procedure TMainForm.FormDestroy(Sender: TObject);
begin
    fGridBitmap.Free;
    fStringList.Free;
	//ǂݍ݃t@CpXۑ
	SaveIniString('Caption', Self.Caption);
    inherited;
end;

(* \ *)
procedure TMainForm.FormShow(Sender: TObject);
var
    PrePath: string;
begin
	inherited;	//Ȃ!!!
	//O̓ǂݍݓeČw
//	PrePath := LoadIniString('Caption', Self.Caption);
//	UpdateDropList(PrePath);
//	DroppedAction();
end;

(*
	=====================================================================
	`֘A
	=====================================================================
*)

(* wi`} *)
procedure TMainForm.GridWndProc(var Msg: TMessage);
begin
    if (Msg.Msg = WM_ERASEBKGND) then
    	Msg.Result := 1
    else
    	FGridPreProc(Msg);
end;

(* `ݒ *)
procedure TMainForm.SetDrawCondition();
begin
    with fGridBitmap do begin
        Height      := Screen.Height;
        Width       := Screen.Width;
        Canvas.Font := Self.Font;
    end;
    with Grid do begin
        FGridPreProc    := WindowProc;
        WindowProc      := GridWndProc;
        DefaultColWidth := Self.Width;
        fGridMarginX    := 10;
        fGridMarginY    := (DefaultRowHeight - Self.Canvas.TextHeight('Wg')) div 2;
    end;
end;

(* f[^o *)
function	TMainForm.GetString(AIndex: integer): string;
begin
	if fStringList.Count > AIndex then
    begin
		Result := fStringList[AIndex];
    end else
    begin
		Result := '';
    end;
end;

(* uVF *)
procedure	CanvasBrushColor(ACanvas: TCanvas; State: TGridDrawState);
begin
	if (gdSelected in State) then
    begin
    	ACanvas.Brush.Color := RGB(153, 204, 255);
    end else
    begin
    	ACanvas.Brush.Color := RGB(204, 255, 204);
    end;
end;

(* hԂ *)
procedure	CanvasFillRect(ACanvas: TCanvas; ARect: TRect);
begin
	ACanvas.FillRect(Rect(0, 0, ARect.Right - ARect.Left, ARect.Bottom - ARect.Top));
end;

(* ` *)
procedure	CanvasTextOut(ACanvas: TCanvas; AX, AY: integer; AText: string);
var
    OldBkMode: integer;
begin
    OldBkMode := SetBkMode(ACanvas.Handle, Integer(TRANSPARENT));
    ACanvas.TextOut(AX, AY, AText);
    SetBkMode(ACanvas.Handle, OldBkMode);
end;

(* ` *)
procedure TMainForm.GridDrawCell(Sender: TObject; ACol, ARow: Integer;
  Rect: TRect; State: TGridDrawState);
var
    str : string;
begin
    //hԂ̐F
    CanvasBrushColor(fGridBitmap.Canvas, State);
    //hԂ
    CanvasFillRect(fGridBitmap.Canvas, Rect);
    //f[^o
    str := Format('%5d:%s', [ARow, GetString(ARow)]);
    //f[^`
    CanvasTextOut(fGridBitmap.Canvas, fGridMarginX, fGridMarginY, str);
    BitBlt(
        Grid.Canvas.Handle,
        Rect.Left,
        Rect.Top,
        Rect.Right - Rect.Left,
        Rect.Bottom - Rect.Top,
        fGridBitmap.Canvas.Handle, 0, 0, SRCCOPY
    );
end;

(*
	=====================================================================
	܂
	=====================================================================
*)
const
	idSysAbout   = 100;

(* VXej[ύX *)
procedure	TMainForm.ModifySysMenu();
begin
	//Zp[^ǉ
    AppendMenu(GetSystemMenu(Handle, False), MF_SEPARATOR, 0, '');
	//j[ǉ
    AppendMenu(GetSystemMenu(Handle, False), MF_STRING, idSysAbout, 'o[W');
end;

(* ǉj[ *)
procedure	TMainForm.WMSysCommand(var Msg: TWMSysCommand);
begin
	case Msg.CmdType of
        idSysAbout  : AboutBox.ShowModal();
    end;
    inherited;
end;

(* Ⴍ\ *)
procedure TMainForm.ImgTitleClick(Sender: TObject);
begin
	if (Self.ClientHeight > ImgTitle.Height) then
    begin
		Self.ClientHeight := Grid.DefaultRowHeight * 0 + ImgTitle.Height;
    end else
    begin
		Self.ClientHeight := Grid.DefaultRowHeight * 8 + ImgTitle.Height;
    end;
end;

end.
